package com.pixelized.server.lwa.server.rest.character

import com.pixelized.server.lwa.server.Engine
import com.pixelized.server.lwa.utils.extentions.characterSheetId
import com.pixelized.server.lwa.utils.extentions.exception
import com.pixelized.shared.lwa.protocol.rest.APIResponse
import com.pixelized.shared.lwa.protocol.websocket.ApiSynchronisation
import io.ktor.server.response.respond
import io.ktor.server.routing.RoutingContext

fun Engine.deleteCharacter(): suspend RoutingContext.() -> Unit {
    return {
        try {
            // get the query parameter
            val characterSheetId = call.parameters.characterSheetId
            // delete the character sheet.
            characterService.deleteCharacterSheet(
                characterSheetId = characterSheetId
            )
            // API & WebSocket responses.
            call.respond(
                message = APIResponse.success()
            )
            webSocket.emit(
                value = ApiSynchronisation.CharacterSheetDelete(
                    timestamp = System.currentTimeMillis(),
                    characterSheetId = characterSheetId,
                ),
            )
        } catch (exception: Exception) {
            call.exception(
                exception = exception
            )
        }
    }
}